
#include "objects.h"

Hyperboloid_2( xaxis, yaxis, zaxis, length, center, depth,
               clockwise, primitive )
float xaxis, yaxis, zaxis;
float length;
Point center;
int depth;
char clockwise;
int primitive;
{
#if 0
    int i, j;        /* i/phi    j/theta */
    float is, js;
    float phi, theta, step;
    float fphiSize, fthetaSize;
    int phiSize, thetaSize;
    Point hyperboloid[130][260];
    FILE *fp;
    extern char *filename;

    fp = fopen( filename, "w" );

    step = (float)(M_PI / pow( (double)2, (double)depth ));
    fphiSize = (M_PI / step) + 1.;
    fthetaSize = (M_PI / step) + 1.;
    phiSize = (int)fphiSize;
    thetaSize = (int)fthetaSize;

    for( i = 0; i < phiSize; i++ ) {
        for( j = 0; j < thetaSize; j++ ) {
           double cosi, cosj;
           is = -(M_PI/2.) + i * step;
           js = -(M_PI/2.) + j * step;
           cosi = cos( is );
           cosj = cos( js );
           if( NEAR_ZERO( cosi ) ) cosi = 10.;
           if( NEAR_ZERO( cosj ) ) cosj = 5.;
           hyperboloid[i][j].x = xaxis / cosi * cos( js ) + center.x;
           hyperboloid[i][j].y = yaxis / cosi * sin( js ) / cosj + center.y;
           hyperboloid[i][j].z = zaxis / cosi * sin( is ) + center.z;
        }
    }

    /* Print the Coordinates of the points */
    fprintf( fp, "%d\n", phiSize * thetaSize );
    for( i = 0; i < phiSize; i++ ) {
        for( j = 0; j < thetaSize; j++ ) {
            fprintf( fp, "%f %f %f\n", hyperboloid[i][j].x, hyperboloid[i][j].y,
                                       hyperboloid[i][j].z );
        }
    }

    /* Print the Conectivity data of the points */
    fprintf( fp, "%d\n", (phiSize-1) * (thetaSize-1) );
    if( clockwise ) {
        for( i = 0; i < thetaSize-1; i++ ) {
            for( j = 0; j < phiSize-1; j++ ) {
                fprintf( fp, "4 %d %d %d %d\n",
                           j*thetaSize+i+1,     j*thetaSize+(i+1)+1,
                       (j+1)*thetaSize+i+1, (j+1)*thetaSize+(i+1)+1 );
            }
        }
    }
    else {    /* counterClockwise */
        for( i = 0; i < thetaSize-1; i++ ) {
            for( j = 0; j < phiSize-1; j++ ) {
                fprintf( fp, "4 %d %d %d %d\n",
                           j*thetaSize+i+1, (j+1)*thetaSize+i+1,
                   (j+1)*thetaSize+(i+1)+1, j*thetaSize+(i+1)+1 );
            }
        }
    }
#endif
}
